import 'dart:typed_data';
import 'moderatorCapsuleEntry.dart';

enum capsuleFieldType { empty, tangle, katamari, threadEntries, groupEntries }

class ModeratorCapsule {
  //Uint8List tangle; //MUST have token for POST
  Uint8List katamari; //OPTIONAL token for POST
  Uint8List moderatorEntrySet; //singular thread entries
  Uint8List groupEntries; //group entries pointing to thread entries

  ModeratorCapsule(this.katamari, this.moderatorEntrySet, this.groupEntries);
  bool get isDEADBEEF {
    if (katamari.isEmpty) return true;
    return false;
  }

  factory ModeratorCapsule.fromBinary(Uint8List data) {
    var bdata = new ByteData.view(data.buffer);

    int dataLength = bdata.getUint16(0);
    if (data.lengthInBytes != dataLength) {
      return ModeratorCapsule(Uint8List(0), Uint8List(0), Uint8List(0));
    }
    var wi = 2;
    //skip 2 reserved bytes
    wi += 2;
    //Uint8List _tangle = Uint8List(0); //MUST have key to talk to moderator
    Uint8List _katamari =
        Uint8List(dataLength); //currently OPTIONAL key for your requests
    Uint8List _modEntrySet =
        Uint8List(dataLength); //single thread entries with keys
    //Uint8List _groupEntries = Uint8List(0); //single group entries with keys

    //tangle is a must
    /*if (bdata.getInt8(wi) == capsuleFieldType.empty) {
      wi++;
    } else {
      wi++;
      int dataLength = bdata.getInt16(wi);
      wi = wi + 2;
      for (int i = 0; i < dataLength; i++) {
        _tangle.add(data[wi + i]);
      }
    }*/
    //katamari
    int kk = 0;
    if (bdata.getUint8(wi) == capsuleFieldType.empty) {
      wi++;
    } else {
      wi++;
      int kdataLength = bdata.getUint16(wi);
      print('katalen ' + kdataLength.toString());
      wi = wi + 2;
      for (int i = 0; i < kdataLength; i++) {
        _katamari[kk++] = data[wi + i];
      }
      wi += kdataLength;
    }
    int tt = 0;
    if (bdata.getUint8(wi) == capsuleFieldType.empty) {
      wi++;
    } else {
      wi++;
      int mdataLength = bdata.getUint16(wi);
      print('moder ' + mdataLength.toString());
      wi = wi + 2;
      for (int i = 0; i < mdataLength; i++) {
        _modEntrySet[tt++] = data[wi + i];
      }
      wi += mdataLength;
    }
    /*if (bdata.getInt8(wi) == capsuleFieldType.empty) {
      wi++;
    } else {
      wi++;
      int dataLength = bdata.getInt16(wi);
      wi = wi + 2;
      for (int i = 0; i < dataLength; i++) {
        _groupEntries.add(data[wi + i]);
      }
    }*/
    return ModeratorCapsule(
        _katamari.sublist(0, kk), _modEntrySet.sublist(0, tt), Uint8List(0));
  }

  Uint8List get binary {
    Uint8List b = Uint8List(942000);
    var bdata = new ByteData.view(b.buffer);
    //first word is lenght
    int wi = 2;
    //skip tangle for historical reasons
    bdata.setUint16(wi, capsuleFieldType.empty.index);
    wi += 2;
    /*bdata.setUint8(wi++, capsuleFieldType.tangle.index);
    bdata.setUint16(wi, tangle.lengthInBytes);
    wi += 2;
    tangle.forEach((element) {
      bdata.setUint8(wi++, element);
    });*/

    if (katamari.isEmpty) {
      bdata.setUint8(wi++, capsuleFieldType.empty.index);
    } else {
      bdata.setUint8(wi++, capsuleFieldType.katamari.index);
      bdata.setUint16(wi, katamari.lengthInBytes);
      wi += 2;
      katamari.forEach((element) {
        bdata.setUint8(wi++, element);
      });
    }
    if (moderatorEntrySet.isEmpty) {
      bdata.setUint8(wi++, capsuleFieldType.empty.index);
    } else {
      bdata.setUint8(wi++, capsuleFieldType.threadEntries.index);
      bdata.setUint16(wi, moderatorEntrySet.lengthInBytes);
      wi += 2;
      moderatorEntrySet.forEach((element) {
        bdata.setUint8(wi++, element);
      });
    }
    if (groupEntries.isEmpty) {
      bdata.setUint8(wi++, capsuleFieldType.empty.index);
    } else {
      bdata.setUint8(wi++, capsuleFieldType.groupEntries.index);
      bdata.setUint16(wi, groupEntries.lengthInBytes);
      wi += 2;
      groupEntries.forEach((element) {
        bdata.setUint8(wi++, element);
      });
    }
    bdata.setUint16(0, wi);
    return b.sublist(0, wi);
  }
}
