import 'dart:typed_data';
import 'ModeratorCapsuleEntry.dart';

enum capsuleFieldType { empty, tangle, katamari, threadEntries, groupEntries }

class ModeratorCapsule {
  //Uint8List tangle; //MUST have token for POST
  Uint8List katamari; //OPTIONAL token for POST
  Uint8List threadEntries; //singular thread entries
  Uint8List groupEntries; //group entries pointing to thread entries

  ModeratorCapsule(this.katamari, this.threadEntries, this.groupEntries);

  factory ModeratorCapsule.fromBinary(Uint8List data) {
    var bdata = new ByteData.view(data.buffer);
    data.buffer.asUint8List().toList();
    int dataLength = bdata.getUint32(0);
    var wi = 6; //skipping tangloid
    Uint8List _tangle = Uint8List(0); //MUST have key to talk to moderator
    Uint8List _katamari =
        Uint8List(dataLength); //currently OPTIONAL key for your requests
    Uint8List _threadEntries =
        Uint8List(dataLength); //single thread entries with keys
    Uint8List _groupEntries = Uint8List(0); //single group entries with keys

    //tangle is a must
    /*int tadataLength = 0;
    if (bdata.getInt8(wi) == capsuleFieldType.empty) {
      wi++;
    } else {
      wi++;
      tadataLength = bdata.getInt16(wi);
      wi = wi + 2;
      for (int i = 0; i < tadataLength; i++) {
        _tangle.add(data[wi + i]);
      }
    }*/
    //katamari
    int kdataLength = 0;
    if (bdata.getUint8(wi) == capsuleFieldType.empty.index) {
      wi++;
    } else {
      wi++;
      kdataLength = bdata.getUint16(wi);
      wi = wi + 2;
      var moo = wi + kdataLength;
      print(moo);
      print(bdata.lengthInBytes);
      try {
        for (int i = 0; i < kdataLength; i++) {
          //_katamari.add(data[wi + i]);
          _katamari[i] = bdata.getUint8(wi + i);
        }
      } catch (e) {
        print('missing byte');
        print(moo);
        print(bdata.lengthInBytes);
      }
      wi += kdataLength;
    }
    var tdataLength = 0;
    if (bdata.getUint8(wi) == capsuleFieldType.empty.index) {
      wi++;
    } else {
      wi++;
      tdataLength = bdata.getUint16(wi);
      wi = wi + 2;
      for (int i = 0; i < tdataLength; i++) {
        _threadEntries[i] = bdata.getUint8(wi + i);
        //_threadEntries.add(data[wi + i]);
      }
      wi += tdataLength;
    }
    if (bdata.getUint8(wi) == capsuleFieldType.empty.index) {
      wi++;
    } else {
      wi++;
      int xdataLength = bdata.getUint16(wi);
      wi = wi + 2;
      for (int i = 0; i < xdataLength; i++) {
        _groupEntries[wi + i] = bdata.getUint8(wi + i);
      }
    }
    return ModeratorCapsule(
        kdataLength != 0 ? _katamari.sublist(0, kdataLength) : Uint8List(0),
        _threadEntries.sublist(0, tdataLength),
        _groupEntries);
  }

  Uint8List get binary {
    Uint8List b = Uint8List(942000);
    var bdata = new ByteData.view(b.buffer);
    //first longword is lenght
    int wi = 4;
    //skip tangle for historical reasons
    bdata.setUint8(wi, capsuleFieldType.empty.index);
    wi += 2; //
    /*bdata.setUint8(wi++, capsuleFieldType.tangle.index);
    bdata.setUint16(wi, tangle.lengthInBytes);
    wi += 2;
    tangle.forEach((element) {
      bdata.setUint8(wi++, element);
    });*/

    if (katamari.isEmpty) {
      bdata.setUint8(wi++, capsuleFieldType.empty.index);
    } else {
      bdata.setUint8(wi++, capsuleFieldType.katamari.index);
      bdata.setUint16(wi, katamari.lengthInBytes);
      wi += 2;
      katamari.forEach((element) {
        bdata.setUint8(wi++, element);
      });
    }
    if (threadEntries.isEmpty) {
      bdata.setUint8(wi++, capsuleFieldType.empty.index);
    } else {
      bdata.setUint8(wi++, capsuleFieldType.threadEntries.index);
      bdata.setUint16(wi, threadEntries.lengthInBytes);
      wi += 2;
      threadEntries.forEach((element) {
        bdata.setUint8(wi++, element);
      });
    }
    if (groupEntries.isEmpty) {
      bdata.setUint8(wi++, capsuleFieldType.empty.index);
    } else {
      bdata.setUint8(wi++, capsuleFieldType.groupEntries.index);
      bdata.setUint16(wi, groupEntries.lengthInBytes);
      wi += 2;
      groupEntries.forEach((element) {
        bdata.setUint8(wi++, element);
      });
    }
    bdata.setUint32(0, wi);
    return b.sublist(0, wi);
  }
}
