import 'dart:typed_data';
import 'package:bit_array/bit_array.dart';

class ModeratorEntryFlags {
  BitArray _data = BitArray(16);
  ModeratorEntryFlags(Uint8List data) {
    if (data.isEmpty) {
      _data = BitArray(16);
    } else {
      var bdata = new ByteData(16);
      bdata.setUint8(0, data[0]);
      bdata.setUint8(1, data[1]);

      _data = BitArray.fromByteBuffer(bdata.buffer);
      //_data = BitArray.fromByteBuffer(data.buffer);
    }
  }
  factory ModeratorEntryFlags.fromInt(int i) {
    var ii = Uint8List(i);
    return ModeratorEntryFlags(ii.buffer.asUint8List());
    //_data = BitArray.fromByteBuffer(ii.buffer);
  }

  int get hint {
    var t = _data.byteBuffer.asUint16List();
    return t[0];
  }

  Uint8List get binary => _data.byteBuffer.asUint8List(0, 2);
  void set isPost(bool f) => f ? _data.setBit(0) : _data.clearBit(0);
  void set isReply(bool f) => f ? _data.setBit(1) : _data.clearBit(1);
  void set isMuted(bool f) => f ? _data.setBit(4) : _data.clearBit(4);

  void set isGroup(bool f) => f ? _data.setBit(5) : _data.clearBit(5);
  void set isGroupMember(bool f) => f ? _data.setBit(6) : _data.clearBit(6);
  void set moderate(bool f) => f ? _data.setBit(7) : _data.clearBit(7);
  void set isHome(bool f) => f ? _data.setBit(8) : _data.clearBit(8);
  void set isSeen(bool f) => f ? _data.setBit(9) : _data.clearBit(9);

  void set isHidden(bool f) => f ? _data.setBit(10) : _data.clearBit(10);
  void set isHiddenDecrypted(bool f) =>
      f ? _data.setBit(11) : _data.clearBit(11);
  void set isRegularVisitor(bool f) =>
      f ? _data.setBit(12) : _data.clearBit(12);
  void set attachements(bool f) => f ? _data.setBit(13) : _data.clearBit(13);
  void set nsfw(bool f) => f ? _data.setBit(15) : _data.clearBit(15);

  bool get isPost => _data[0];
  bool get isReply => _data[1];

  bool get isMuted => _data[4];
  bool get isGroup => _data[5];
  bool get isGroupMember => _data[6];
  bool get moderate => _data[7];
  bool get isHome => _data[8];
  bool get isSeen => _data[9];
  bool get isHidden => _data[10];
  bool get isHiddenDecrypted => _data[11];
  bool get isRegularVisitor => _data[12];
  bool get attachements => _data[13];
  bool get nsfw => _data[15];
}
