import 'dart:typed_data';

class ModeratorViewSettings {
  final bool moderate;
  final bool authorHead;
  final bool authorColorHint;
  final bool debugInfo;
  final bool allowComment;
  final bool createThreadBox;
  final bool showOnlyRoot;
  final String rootPage;
  final int itemLimit;
  final bool showHeader;
  final bool encryptedItems;
  final Set<int> missingEncryptedMembers;
  final Map<int, Uint8List> groupDecryptors;
  final int enforcedGroup;
  final Map<int, Uint8List> shortLinks;
  final Set<int> xxStash;
  final bool sandbox;
  final bool parseLinks;
  final String queriedAuthor;
  final String queriedMentions;
  String nick;
  bool disallowWithNoAttachements;
  bool allowNSFW;
  Set<int> excludedAuthors = {};

  ModeratorViewSettings(
      this.moderate,
      this.authorHead,
      this.authorColorHint,
      this.debugInfo,
      this.allowComment,
      this.createThreadBox,
      this.showOnlyRoot,
      this.rootPage,
      this.itemLimit,
      this.showHeader,
      this.encryptedItems,
      this.missingEncryptedMembers,
      this.groupDecryptors,
      this.enforcedGroup,
      this.shortLinks,
      this.xxStash,
      this.sandbox,
      this.parseLinks,
      this.nick,
      this.disallowWithNoAttachements,
      this.allowNSFW,
      this.queriedAuthor,
      this.queriedMentions,
      this.excludedAuthors);
}
